$COM

'===========================================================================
'                Original program by Rowan Crowe ( MoonRock )
'   Adapted by Kevin Diggins for demonstrating some BASM v4.0 features
'                   This demonstration requires a VGA
'===========================================================================

GetTextScreen


CONST Pixel       =   200
CONST FactorX     =    -1
CONST FactorY     =     0
CONST DirectionX  =    -1
CONST DirectionY  =     0
CONST Max_X       =   639
CONST Max_Y       =   479


DIM   X(201)
DIM   Y(201)

SCREEN 12

FOR I  = 0 to Pixel
  Tmp  = RANDOM(Max_X)
  X(I) = Tmp
  Tmp  = RANDOM(Max_Y)
  Y(I) = Tmp
NEXT


DO
  ProcessPlane(1,70,1)
  ProcessPlane(71,140,2)
  ProcessPlane(141,200,3)
  K = INKEY
  IF K THEN EXIT LOOP
LOOP

SCREEN 0

PutTextScreen





SUB ProcessPlane(Start1,End1,Speed1)
LOCAL I, Tmp, Tmp1, Tmp2, T, Kol

FOR I  = Start1 TO End1

  Tmp1 = X(I)
  Tmp2 = Y(I)
  T    =  FactorX * Speed1
  PSET (Tmp1,Tmp2),0

  Tmp  = X(I)
  INCR Tmp,T
  T    =  FactorY * Speed1
  X(I) =  Tmp

  Tmp  = Y(I)
  INCR Tmp,T
  Y(I) =  Tmp

  GOSUB Xsub

  IF Tmp <=  -1 THEN
    X(I)  =  Max_X
    Tmp   =  RANDOM(Max_Y)
    Y(I)  =  Tmp
  END IF

  GOSUB Xsub

  IF Tmp >=  640 THEN
    X(I)  =  0
    Tmp   =  RANDOM(Max_Y)
    Y(I)  =  Tmp
  END IF

  GOSUB Ysub

  IF Tmp <=  -1 THEN
    Y(I)  =  Max_Y
    Tmp   =  RANDOM(Max_X)
    X(I)  =  Tmp
  END IF

  GOSUB Ysub

  IF Tmp >=  Max_Y THEN
    Y(I)  =  0
    Tmp   = RANDOM(Max_X)
    X(I)  =  Tmp
  END IF

  Tmp1 = X(I)
  Tmp2 = Y(I)
  Kol  = RANDOM(15)
  PSET (Tmp1,Tmp2),Kol
NEXT
EXIT SUB

Xsub:
Tmp = X(I)
RETURN


Ysub:
Tmp = Y(I)
RETURN

END SUB








'           Ŀ
'             These 2 subs save & restore the DOS screen    
'           

$Include "TextScrn.Inc"
